

#include "lzo1x.h"

#include "iohelpers.h"

using namespace std;


int main()
{
	lzo_init();

	string s;

	read_all_input(s);

	string res;
	size_t out_len;
	char wrkmem[LZO1X_1_MEM_COMPRESS];

	res.resize(out_len=(2*s.length() + 1024), 0);

	lzo1x_1_compress((unsigned char*)s.c_str(), s.length(),
		(unsigned char*)&res[0], &out_len, wrkmem);


	string res2;
	size_t out_len2;
	res2.resize(out_len2=(2*res.length() + 1024), 0);
	lzo1x_decompress((unsigned char*)res.c_str(), out_len,
		(unsigned char*)&res2[0], &out_len2, nullptr);
		
	res2.resize(out_len2);
	cout << "orig length: " << s.length() << endl;
	cout << "compressed length: " << out_len << endl;
	cout << "decompressed length: " << out_len2 << endl;
	cout << res2 << endl;
	return 0;
}
